(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
	typeof define === 'function' && define.amd ? define(factory) :
	(global.highlight = factory());
}(this, (function () { 'use strict';

'use strict';

function encode(str, jsUnicode) {
	if ( jsUnicode === void 0 ) jsUnicode = true;

	var result = [];
	var len = str.length;
	for (var i = 0; i < len; i++) {
		var hex = str.charAt(i).charCodeAt(0).toString(16);
		if (jsUnicode) {
			result.push(("\\u" + (((("000" + hex)).slice(-4)))));
		} else {
			result.push(hex);
		}
	}
	return result.join('')
}

'use strict';

function onlyUnique(value, index, arr) {
	return arr.indexOf(value) === index && value
}

function highlight(source, q, options) {
	if ( options === void 0 ) options = {};

	var tpl = options.tpl; if ( tpl === void 0 ) tpl = '<mark>$&</mark>';
	var split = options.split; if ( split === void 0 ) split = true;
	var caseSensitive = options.caseSensitive; if ( caseSensitive === void 0 ) caseSensitive = true;
	var words = (split ? q.split(' ') : [q])
		.map(function (word) { return word.trim(); })
		.filter(onlyUnique)
		.sort(function (a, b) { return b.length - a.length; })
		.map(function (word) { return encode(word); });

	var regex = new RegExp(("" + (words.join('|'))), caseSensitive ? 'g' : 'ig');
	return source.replace(regex, tpl)
}

return highlight;

})));
//# sourceMappingURL=index.js.map
